<template>
  <div class="view-table-content">
    <div class="view-dataSpecies-left">
      <MenuTree :currentNodeKey="currentNodeKey" nodeKey="id" :treedata="menuTreeData" @TreeNodeclick="treeNodeClick" v-bind="treeObj"> </MenuTree>
    </div>
    <div class="view-dataSpecies-right">
      <div class="view-dataType-title">
        <div class="view-dataType-title-btn">
          <el-button type="success" @click="openDialog()" :disabled="currentNode && currentNode.type == 0">新增</el-button>
          <el-button type="warning" @click="remove(tableCheckItems)" :disabled="tableCheckItems.length == 0">删除</el-button>
        </div>
        <div class="view-dataType-title-search">
          <el-input placeholder="请输入关键字" v-model="keyWord" class="input1">
            <el-button slot="append" icon="el-icon-search" @click="searchClick"></el-button>
          </el-input>
        </div>
      </div>
      <div class="view-dataType-table">
        <LTable ref="table" @selection-change="selection" :defaultFetch="false" :fetch="fetch" :columns="columns" :dataSource="tableData" :options="options" :pagination="tableRequset"></LTable>
      </div>
      <!-- 添加或修改定检任务子对话框 -->
      <el-dialog :title="dialogTitle" :visible.sync="dialogVisible" width="600px" :before-close="handleClose">
        <el-form ref="form" :model="form" label-width="80px">
          <el-form-item label="机号" prop="aircraftId">
            <el-input v-model="form.aircraftId" placeholder="请输入机号" />
          </el-form-item>
          <el-form-item label="机型" prop="aircraftModel">
            <el-input v-model="form.aircraftModel" placeholder="请输入机型" />
          </el-form-item>
          <el-form-item label="任务名称" prop="name">
            <el-date-picker clearable v-model="form.name" type="date" value-format="YYYY-MM-DD" placeholder="请选择任务名称"> </el-date-picker>
          </el-form-item>
          <el-form-item label="任务编码" prop="code">
            <el-input v-model="form.code" placeholder="请输入任务编码" />
          </el-form-item>
          <el-form-item label="维修时间" prop="endTime">
            <el-date-picker clearable v-model="form.endTime" type="date" value-format="YYYY-MM-DD" placeholder="请选择维修时间"> </el-date-picker>
          </el-form-item>
          <el-form-item label="剩余时间" prop="remainTime">
            <el-input v-model="form.remainTime" placeholder="请输入剩余时间" />
          </el-form-item>
          <el-form-item label="专业" prop="specialty">
            <el-input v-model="form.specialty" placeholder="请输入专业" />
          </el-form-item>
          <el-form-item label="下发日期" prop="issueDate">
            <el-date-picker clearable v-model="form.issueDate" type="date" value-format="YYYY-MM-DD" placeholder="请选择下发日期"> </el-date-picker>
          </el-form-item>
          <el-form-item label="完成日期" prop="finishDate">
            <el-date-picker clearable v-model="form.finishDate" type="date" value-format="YYYY-MM-DD" placeholder="请选择完成日期"> </el-date-picker>
          </el-form-item>
          <el-form-item label="工作人" prop="staff">
            <el-input v-model="form.staff" placeholder="请输入工作人" />
          </el-form-item>
          <el-form-item label="复查人" prop="reviewBy">
            <el-input v-model="form.reviewBy" placeholder="请输入复查人" />
          </el-form-item>
          <el-form-item label="单位" prop="unitName">
            <el-input v-model="form.unitName" placeholder="请输入单位" />
          </el-form-item>
          <el-form-item label="维修内容" prop="contents">
            <el-input v-model="form.contents" placeholder="请输入维修内容" />
          </el-form-item>
        </el-form>

        <span slot="footer" class="dialog-footer">
          <el-button @click="handleClose">取 消</el-button>
          <el-button type="primary" @click="submit">确 定</el-button>
        </span>
      </el-dialog>
    </div>
  </div>
</template>

<script>
import { getSmaskSub, getAircaftTypeAndModelTree, addSmaskSub, updateSmaskSub, removeSmaskSub } from '@/api/als/smaskSub'
import { deepClone, debounce } from '@/utils/index'
export default {
  name: 'SmaskSub',
  components: {},
  data() {
    // 这里存放数据
    return {
      dialogTitle: '新增',
      dialogVisible: false,
      keyWord: '',
      aircaftModelIdList: [],
      currentNodeKey: null,
      currentNode: null,
      menuTreeData: [],
      treeObj: {
        title: '所属机种',
        activityheight: '275px',
        searchIcon: false,
        configure: {
          children: 'children',
          label: 'label'
        }
      },
      typeTree: {
        children: 'children',
        label: 'label'
      },
      searchValue: '',
      columns: [
        { prop: 'id', label: '编号' },
        {
          prop: 'aircraftId',
          label: '机号'
        },
        {
          prop: 'aircraftModel',
          label: '机型'
        },
        {
          prop: 'name',
          label: '任务名称'
        },
        {
          prop: 'code',
          label: '任务编码'
        },
        {
          prop: 'endTime',
          label: '维修时间'
        },
        {
          prop: 'remainTime',
          label: '剩余时间'
        },
        {
          prop: 'specialty',
          label: '专业'
        },
        {
          prop: 'issueDate',
          label: '下发日期'
        },
        {
          prop: 'finishDate',
          label: '完成日期'
        },
        {
          prop: 'staff',
          label: '工作人'
        },
        {
          prop: 'reviewBy',
          label: '复查人'
        },
        {
          prop: 'unitName',
          label: '单位'
        },
        {
          prop: 'contents',
          label: '维修内容'
        },
        {
          prop: 'status',
          label: '状态'
        },
        {
          button: true,
          label: '操作',
          width: '240px',
          group: [
            {
              name: '编辑',
              type: 'text',
              round: false,
              plain: false,
              onClick: (row, index, scope) => {
                _this.handUpdate(row)
              }
            },
            {
              name: '删除',
              type: 'text',
              round: false,
              plain: false,
              onClick: (row, index, scope) => {
                _this.remove([row])
              }
            }
          ]
        }
      ],
      options: {
        stripe: true, // 斑马纹
        mutiSelect: true, // 多选框
        index: false, // 显示序号， 多选则 mutiSelect
        loading: false, // 表格动画
        initTable: false, // 是否一挂载就加载数据
        border: true,
        height: 'calc(100vh - 300px)'
      },
      tableCheckItems: [],
      tableData: [],
      tableRequset: {
        total: 0,
        pageIndex: 1,
        pageSize: 10,
        searchValue: ''
      },
      form: {
        id: '',
        aircraftId: '',
        aircraftModel: '',
        name: '',
        code: '',
        endTime: '',
        remainTime: '',
        specialty: '',
        issueDate: '',
        finishDate: '',
        staff: '',
        reviewBy: '',
        unitName: '',
        contents: '',
        status: '',
        tenantId: '',
        version: '',
        delFlag: '',
        createBy: '',
        createTime: '',
        updateBy: '',
        updateTime: ''
      },
      debounceFn: debounce(this.fetch, 500)
    }
  },
  watch: {
    keyWord() {
      this.tableRequset.pageIndex = 1
      this.debounceFn()
    }
  },
  mounted() {
    this.getAircaftTypeAndModelTreeAPI()
  },
  methods: {
    async getAircaftTypeAndModelTreeAPI(params) {
      const { data } = await getAircaftTypeAndModelTree(params)
      this.menuTreeData = data
      if (data.length) {
        this.currentNodeKey = data[0].value
        this.currentNode = data[0]
        this.aircaftModelIdList = this.getTreeLeafData(data[0]?.children).map((e) => e.id)
        this.getSmaskSubAPI({ aircaftModelIdList: this.aircaftModelIdList })
      }
    },

    async removeSmaskSubAPI(params) {
      try {
        const { success } = await removeSmaskSub(params)
        if (success) {
          this.$message({
            type: 'success',
            message: '操作成功!'
          })
          await this.getSmaskSubAPI({ aircaftModelIdList: this.aircaftModelIdList })
          this.handleClose()
        }
      } catch (error) {}
    },

    getTreeLeafData(list) {
      const newArr = []
      function getLeaf(data, arr) {
        data.forEach((e) => {
          if (e.type === 1) {
            arr.push(e)
          }
          if (e.children.length) {
            getLeaf(e.children, arr)
          }
        })
      }
      getLeaf(list, newArr)
      return newArr
    },

    async getSmaskSubAPI(params) {
      if (this.$refs.table) this.$refs.table.clearSelection()
      const { keyWord } = this
      const { pageSize, pageIndex } = this.tableRequset
      const {
        data: { list, total }
      } = await getSmaskSub({ pageSize, pageIndex, keyWord, ...params })
      this.tableData = list
      this.tableRequset.total = total
    },

    fetch() {
      this.getSmaskSubAPI({ aircaftModelIdList: this.aircaftModelIdList })
    },

    searchClick() {
      this.getSmaskSubAPI({ aircaftModelIdList: this.aircaftModelIdList })
    },

    async addSmaskSubAPI() {
      try {
        delete this.form.aircaftModelName
        const { success } = await addSmaskSub({ ...this.form })
        if (success) {
          this.$message({
            type: 'success',
            message: '操作成功!'
          })
          this.getSmaskSubAPI({ aircaftModelIdList: this.aircaftModelIdList })
        }
      } catch (error) {}
    },

    async updateSmaskSubAPI() {
      try {
        const { success } = await updateSmaskSub({ ...this.form })
        if (success) {
          this.$message({
            type: 'success',
            message: '操作成功!'
          })
          this.getSmaskSubAPI({ aircaftModelIdList: this.aircaftModelIdList })
        }
      } catch (error) {}
    },

    treeNodeClick(data) {
      this.$refs.table.clearSelection()
      this.currentNodeKey = data.id
      this.currentNode = data
      this.aircaftModelIdList = this.getTreeLeafData(data.children.length ? data.children : [data]).map((e) => e.id)
      this.getSmaskSubAPI({ aircaftModelIdList: this.aircaftModelIdList })
    },

    openDialog() {
      this.dialogTitle = '新增'
      this.dialogVisible = true
      this.form.aircaftModelName = this.currentNode.label
      this.form.aircaftModelId = this.currentNode.id
    },

    handleClose() {
      this.dialogVisible = false
      this.form = {
        id: '',
        aircraftId: '',
        aircraftModel: '',
        name: '',
        code: '',
        endTime: '',
        remainTime: '',
        specialty: '',
        issueDate: '',
        finishDate: '',
        staff: '',
        reviewBy: '',
        unitName: '',
        contents: '',
        status: '',
        tenantId: '',
        version: '',
        delFlag: '',
        createBy: '',
        createTime: '',
        updateBy: '',
        updateTime: ''
      }
    },

    handUpdate(row) {
      this.dialogTitle = '编辑'
      this.form = deepClone(row)
      this.dialogVisible = true
    },

    submit() {
      switch (this.dialogTitle) {
        case '编辑':
          this.updateSmaskSubAPI()
          this.handleClose()
          break
        case '新增':
          this.addSmaskSubAPI()
          this.handleClose()
          break
      }
    },

    selection(val) {
      this.tableCheckItems = val
    },

    remove(row) {
      this.$confirm('是否删除该机种', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      })
        .then(() => {
          this.removeSmaskSubAPI(row.map((e) => e.id))
        })
        .catch(() => {})
    }
  }
}
</script>

<style lang="scss" scoped>
@import '../index.scss';
</style>
